/*
** psfGP.c - Generate PSF Dependency Graph Representation in GraphPlace format.
**
** H.T.G. Weffers
**
*/

#include <stdio.h>

#include "psf_prototype.h"
#include "psf_standards.h"
#include "imports.h"

static void gpheader()
{
	fprintf(stdout,"%%!PS-Adobe-3.0 EPSF-3.0\n");
	fprintf(stdout,"%%%% %s %s\n","GraphPlace sources created by","`psf -G gp'");
	fprintf(stdout,"%%%%\n");
	fprintf(stdout,"\n\n");
}

static void gptrailer()
{
	fprintf(stdout,"\n\n");
	fprintf(stdout,"%%%% %s\n","End-Of-File");
	fprintf(stdout,"\n");
}

void psfgraphplacegraph ()
{
	module m;
	import i;

	gpheader();


	/* Iteration */
	for (m=module_list; m ; m=m->next)
	{

	fprintf(stdout,"\n\t(%s) () \"%s\" node",m->name,m->name);

        if (m->where)
        {
              /* Iteration */
              for (i=m->imports; i ; i=i->next)
              {
                  fprintf(stdout,"\n\t\"%s\" \"%s\" edge",
                            m->name,
                            i->uses->name
                         );
              }
        }
	}

	gptrailer();
}

/*
** Last revision: July 24, 1995
**
** End-Of-Function-Implementation
*/


