#ifndef TREE_H
#define TREE_H

typedef struct tree *treeP;
struct tree {
    treeP parent, left, right;
    blockP block;
    int level;
    char *left_label_a;
    blockP left_label_B;
    ListP right_label_r1, right_label_r2;
};

/* tree.c */
extern treeP new_node PROTO_ARGS((void));
extern void insert_right PROTO_ARGS((blockP B, blockP B2));
extern void insert_left PROTO_ARGS((blockP B, blockP B1));
extern void LabelLeftArc PROTO_ARGS((blockP B, char *a, blockP B1));
extern void LabelRightArc PROTO_ARGS((blockP B, ListP R1, ListP R2));

#define BLOCK(NP)		((NP)->block)
#define PARENT(NP)		((NP)->parent)
#define LEFT(NP)		((NP)->left)
#define RIGHT(NP)		((NP)->right)
#define LEVEL(NP)		((NP)->level)
#define ReachableTau(NP)	((NP)->right_label_r1)
#define Reachable(NP)		((NP)->right_label_r2)
#define SPLITTER(NP)		((NP)->left_label_B)
#define SPLITLABEL(NP)		((NP)->left_label_a)

#endif	/* TREE_H */
