.TH PPPTOTEX 1L "February 2, 1995" "PSF-Toolkit" "LOCAL COMMANDS"
.UC 4
.SH NAME
ppptotex \- generates TeX code from ppp device independent code
.SH SYNOPSIS
.B ppptotex
[
.B \-hv
]
.SH DESCRIPTION
.B ppptotex
generates TeX code out of the device independent code produced
with the
.B \-D
option of
.BR ppp (1L).
The input is read from standard input and written on standard
ouput.
.PP
The generated TeX code can either be formatted with
.BR tex (1),
or
.BR latex (1).
.PP
The following macros will be defined, if they are not already defined.
.TP
.B psfevbegin
Invoked at the beginning of the PSF code. By default it does
.nf
    \\vskip 0.1in
    \\hrule
    \\vskip 0.1in
    \\advance\\hsize by -20pt
.fi
.TP
.B psfevend
Invoked at the end of the PSF code. By default it does
.nf
    \\advance\\hsize by 20pt
    \\hrule
    \\vskip 0.1in
.fi
.TP
.B psfevidpost
String put after an identifier.
.br
Default:
.TP
.B psfevidpre
String put before an identifier.
.br
Default: \\it
.TP
.B psfevkwpost
String put after a keyword.
.br
Default: 
.TP
.B psfevkwpre
String put before a keyword.
.br
Default: \\bf
.TP
.B psfevoppar
String for the || operator.
.br
Default: $\\|$
.TP
.B psfevopalt
String for the + operator.
.br
Default: $+$
.TP
.B psfevopseq
String for the . operator.
.br
Default: $\\cdot$
.TP
.B psfevopstar
String for the * operator.
.br
Default: \\bf *
.TP
.B psfevopsharp
String for the # operator.
.br
Default: \\raise0.2em\\hbox{\\bf\\#}
.TP
.B psfevopdif
String for the \\ operator.
.br
Default: $\\setminus$
.TP
.B psfevopcomm
String for |.
.br
Default: $\\vert$
.SH OPTIONS
.TP
.B \-h
usage summary
.TP
.B \-v
Displays the version-number of ppptotex.
.SH SEE ALSO
.BR ppp (1L),
.BR tex (1),
.BR latex (1)
.SH AUTHOR
Bob Diertens, University of Amsterdam (bobd@fwi.uva.nl)
